// MuleToolBarCtrl.cpp : implementation file
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MuleToolbarCtrl.h"
#include "emule.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CMuleToolbarCtrl

IMPLEMENT_DYNAMIC(CMuleToolbarCtrl, CToolBarCtrl)
CMuleToolbarCtrl::CMuleToolbarCtrl()
{
	m_bUseSpeedMeter = false;
	m_iLastPressedButton = -1;
}

CMuleToolbarCtrl::~CMuleToolbarCtrl()
{
}


BEGIN_MESSAGE_MAP(CMuleToolbarCtrl, CToolBarCtrl)
//	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_NOTIFY_REFLECT(NM_RCLICK, OnNMRclick)
	ON_NOTIFY_REFLECT(TBN_QUERYDELETE, OnTbnQueryDelete)
	ON_NOTIFY_REFLECT(TBN_QUERYINSERT, OnTbnQueryInsert)
	ON_NOTIFY_REFLECT(TBN_GETBUTTONINFO, OnTbnGetButtonInfo)
	ON_NOTIFY_REFLECT(TBN_TOOLBARCHANGE, OnTbnToolbarChange)
END_MESSAGE_MAP()


void CMuleToolbarCtrl::Init(void)
{
	ModifyStyle(0, TBSTYLE_FLAT | WS_BORDER | CCS_ADJUSTABLE);
	SetButtonSize(CSize(60,65));
	SetBitmapSize(CSize(32,35));
	
// add button-images:
	CImageList ImageList;
	CBitmap Bitmap, *pOldBitmap;
	CDC *pCtrlDC = GetDC(), TempDC;
	TempDC.CreateCompatibleDC(pCtrlDC);
	Bitmap.CreateCompatibleBitmap(pCtrlDC, 32 * 11, 35);
	pOldBitmap = TempDC.SelectObject(&Bitmap);
		
	TempDC.FillSolidRect(0,0,32*11,35,RGB(255,0,255));
	TempDC.DrawIcon(CPoint(  0,3), theApp.LoadIcon(IDI_TB_CONNECT));
	TempDC.DrawIcon(CPoint( 32,3), theApp.LoadIcon(IDI_TB_SERVER));
	TempDC.DrawIcon(CPoint( 64,3), theApp.LoadIcon(IDI_TB_TRANSFERS));
	TempDC.DrawIcon(CPoint( 96,3), theApp.LoadIcon(IDI_TB_SEARCH));
	TempDC.DrawIcon(CPoint(128,3), theApp.LoadIcon(IDI_TB_SHARED));
	TempDC.DrawIcon(CPoint(160,3), theApp.LoadIcon(IDI_TB_MESSAGES));
	TempDC.DrawIcon(CPoint(192,3), theApp.LoadIcon(IDI_TB_IRC));
	TempDC.DrawIcon(CPoint(224,3), theApp.LoadIcon(IDI_TB_STATISTICS));
	TempDC.DrawIcon(CPoint(256,3), theApp.LoadIcon(IDI_TB_PREFERENCES));
	TempDC.DrawIcon(CPoint(288,3), theApp.LoadIcon(IDI_TB_DISCONNECT));
	TempDC.DrawIcon(CPoint(320,3), theApp.LoadIcon(IDI_TB_STOPCONNECTING));
	TempDC.SelectObject(pOldBitmap);
	
	ImageList.Create(32, 35, ILC_COLOR32 | ILC_MASK, 11, 1);
	ImageList.Add(&Bitmap, RGB(255,0,255));
	SetImageList(&ImageList);
	ImageList.Detach();
	// FoRcHa
	//Bitmap.Detach();
	Bitmap.DeleteObject();

	ReleaseDC(pCtrlDC);

	// add button-text:
	char cButtonStrings[2000];
	int lLen, lLen2;
	
	strcpy(cButtonStrings, GetResString(IDS_MAIN_BTN_CONNECT));
	lLen = strlen(GetResString(IDS_MAIN_BTN_CONNECT)) + 1;

	lLen2 = strlen(GetResString(IDS_EM_SERVER)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_SERVER), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_TRANS)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_TRANS), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_SEARCH)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_SEARCH), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_FILES)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_FILES), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_MESSAGES)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_MESSAGES), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_IRC)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_IRC), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_STATISTIC)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_STATISTIC), lLen2);
	lLen += lLen2;

	lLen2 = strlen(GetResString(IDS_EM_PREFS)) + 1;
	memcpy(cButtonStrings+lLen, GetResString(IDS_EM_PREFS), lLen2);
	lLen += lLen2;

	memcpy(cButtonStrings+lLen, "\0", 1);

	AddStrings(cButtonStrings);

	// add buttons:	
	for(int i = 0; i < 9; i++)
	{		
		TBButtons[i].fsState	= TBSTATE_ENABLED;
		TBButtons[i].fsStyle	= TBSTYLE_CHECK;//TBSTYLE_CHECKGROUP;
		TBButtons[i].iBitmap	= i;
		TBButtons[i].idCommand	= IDC_TOOLBARBUTTON + i;
		TBButtons[i].iString	= i;

		switch(i)
		{		
		case 0:
		case 8:
			TBButtons[i].fsStyle = TBSTYLE_BUTTON;
			break;
		case 1:
			TBButtons[i].fsState |= TBSTATE_CHECKED;
		}
	}
	m_iLastPressedButton = IDC_TOOLBARBUTTON+1;
	
	TBBUTTON sepButton;
	sepButton.idCommand = 0;
	sepButton.fsStyle = TBSTYLE_SEP;
	sepButton.fsState = TBSTATE_ENABLED;
	sepButton.iString = -1;
	sepButton.iBitmap = -1;
	
	CString config = theApp.glob_prefs->GetToolbarSettings();
	for(i=0;i<config.GetLength();i+=2)
	{
		int index = atoi(config.Mid(i,2));
		if(index==99)
		{
			AddButtons(1,&sepButton);
			continue;
		}
		AddButtons(1,&TBButtons[index]);
	}

	// recalc toolbar-size:	
	Localize();		// at first we have to localize the button-text!!!
	SetBtnWidth();		// then calc and set the button width
	AutoSize();		// and finally call the original (but maybe obsolete) function
	
	// add speed-meter to upper-right corner
	CRect rClient;
	GetClientRect(&rClient);
	rClient.DeflateRect(7,7);
	int iHeight = rClient.Height();
	rClient.left = rClient.right - iHeight * 2;
	if(m_bUseSpeedMeter)
		m_ctrlSpeedMeter.CreateEx(WS_EX_STATICEDGE, NULL, NULL, WS_CHILD | WS_VISIBLE, rClient, this, 123);
	else
		m_ctrlSpeedMeter.CreateEx(WS_EX_STATICEDGE, NULL, NULL, WS_CHILD, rClient, this, 123);
	m_ctrlSpeedMeter.SetRange(0,100);

	// resize speed-meter	
	CRect r;
	GetWindowRect(&r);
	OnSize(0,r.Width(),r.Height());
}

void CMuleToolbarCtrl::Localize(void)
{	
	if(m_hWnd)
	{
		static const int TBStringIDs[]={IDS_MAIN_BTN_CONNECT,IDS_EM_SERVER,IDS_EM_TRANS,IDS_EM_SEARCH,IDS_EM_FILES,IDS_EM_MESSAGES,IDS_IRC,IDS_EM_STATISTIC,IDS_EM_PREFS};
		TBBUTTONINFO tbi;
		tbi.dwMask = TBIF_TEXT;
		tbi.cbSize = sizeof (TBBUTTONINFO);
		CString buffer;

		for (int i = 0; i < sizeof (TBStringIDs) / sizeof(TBStringIDs[0]); i++)
		{
			// buffer.LoadString(TBStringIDs[i]);
			buffer = GetResString(TBStringIDs[i]); // EC
			buffer.Remove('&');
			sprintf(TBStrings[i], "%s", buffer);
			tbi.pszText = TBStrings[i];
			SetButtonInfo(IDC_TOOLBARBUTTON+i, &tbi);
		}

		AutoSize();
		CSize bs=GetButtonSize();
		bs.cx=bs.cx+5;
		SetBtnWidth();
	}
}

void CMuleToolbarCtrl::OnSize(UINT nType, int cx, int cy)
{
	CToolBarCtrl::OnSize(nType, cx, cy);
		
	if(m_ctrlSpeedMeter.m_hWnd && m_bUseSpeedMeter)
	{
		CRect rClient;
		GetClientRect(&rClient);
		rClient.DeflateRect(7,7);

		int iHeight = rClient.Height();
		int iLeft  = rClient.right - iHeight;
		
		CSize csMaxSize;
		GetMaxSize(&csMaxSize);
		if(rClient.left + csMaxSize.cx + 7 > iLeft)
		{	
			m_ctrlSpeedMeter.ShowWindow(SW_HIDE);
			return;
		}
		
		iLeft -= iHeight;
		if(iLeft <= rClient.left + csMaxSize.cx + 7)
			iLeft = rClient.left + csMaxSize.cx + 7;
		rClient.left = iLeft;
		
		m_ctrlSpeedMeter.SetWindowPos(NULL, rClient.left, rClient.top, 
										rClient.Width(), rClient.Height(), 
											SWP_NOZORDER | SWP_SHOWWINDOW);
	}

	SetBtnWidth();
	AutoSize();
}


void CMuleToolbarCtrl::ShowSpeedMeter(bool bShow)
{
	m_bUseSpeedMeter = bShow;
	
	if(bShow)
	{
		if(!m_ctrlSpeedMeter.IsWindowVisible())
		{
			m_ctrlSpeedMeter.EnableWindow(true);
			//m_ctrlSpeedMeter.ShowWindow(SW_SHOW);
		// resize speed-meter	
			CRect r;
			GetWindowRect(&r);
			OnSize(0,r.Width(),r.Height());
		}
	}
	else
	{
		m_ctrlSpeedMeter.EnableWindow(false);
		m_ctrlSpeedMeter.ShowWindow(SW_HIDE);
		CRect rInvalidate;
		m_ctrlSpeedMeter.GetWindowRect(&rInvalidate);
		ScreenToClient(rInvalidate);
		InvalidateRect(rInvalidate);
	}
}

void CMuleToolbarCtrl::SetBtnWidth()
{
	CString strMaxText = "";
	char szBuf[200] = "";
	
	TBBUTTONINFO tbi;
	LPTBBUTTONINFO lptbbi;
	lptbbi = &tbi;
	tbi.dwMask = TBIF_TEXT;
	tbi.cbSize = sizeof (TBBUTTONINFO);
	tbi.pszText = szBuf;
	tbi.cchText = 200;
	
	CDC *pDC = GetDC();
	CFont *pFnt = GetFont();
	CFont *pOldFnt = pDC->SelectObject(pFnt);
	CRect r(0,0,0,0);

/*	for(int i = 0; i < GetButtonCount(); i++)
	{		
		// get button text
		GetButtonInfo(IDC_TOOLBARBUTTON+i, lptbbi);
		// calculate textsize
		pDC->DrawText(szBuf, strlen(szBuf), r, DT_SINGLELINE | DT_CALCRECT);
	}

	pDC->SelectObject(pOldFnt);
	ReleaseDC(pDC); // FoRcHa

	// calculate the max. possible button-size
	int iCalcSize = r.Width() + 10;
*/
	// pooz
	// calculate the max. possible button-size
	int iCalcSize = 0;

	for(int i = 0; i < GetButtonCount(); i++)
	{  
		// get button text
		GetButtonInfo(IDC_TOOLBARBUTTON+i, lptbbi);
		// calculate textsize
		pDC->DrawText(szBuf, strlen(szBuf), r, DT_SINGLELINE | DT_CALCRECT);

		if (r.Width() > iCalcSize)
			iCalcSize = r.Width();
	}

	iCalcSize += 10;

	pDC->SelectObject(pOldFnt);
	ReleaseDC(pDC); // FoRcHa
	// end pooz
	GetClientRect(&r);
	int iMaxPossible = r.Width() / 9;

	// if the buttons are to big, reduze their size
	if(iCalcSize > iMaxPossible)
		iCalcSize = iMaxPossible;

	SetButtonWidth(iCalcSize, iCalcSize);
}

void CMuleToolbarCtrl::OnNMRclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	Customize();
	*pResult = TRUE;
}

void CMuleToolbarCtrl::OnTbnQueryDelete(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = TRUE;
}

void CMuleToolbarCtrl::OnTbnQueryInsert(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = TRUE;
}

void CMuleToolbarCtrl::OnTbnGetButtonInfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTOOLBAR pNMTB = reinterpret_cast<LPNMTOOLBAR>(pNMHDR);
	if (pNMTB->iItem > 8)
	{
		*pResult = FALSE;
	}
	else
	{
		pNMTB->pszText=TBStrings[pNMTB->iItem];
		pNMTB->tbButton = TBButtons[pNMTB->iItem];
		*pResult = TRUE;
	}
}

void CMuleToolbarCtrl::OnTbnToolbarChange(NMHDR *pNMHDR, LRESULT *pResult)
{
	TBBUTTON buttoninfo;
	char config[256]="";
	for(int i=0;i<GetButtonCount();i++)
	{
		if(GetButton(i, &buttoninfo))
			switch(buttoninfo.idCommand)
			{
			case 0:
				sprintf(config, "%s99", config);
				break;
			default:
				sprintf(config, "%s%.2lu", config, buttoninfo.idCommand-IDC_TOOLBARBUTTON);
				break;
			}
	}
	theApp.glob_prefs->SetToolbarSettings(config);
	*pResult = 0;
}
