// PPgAdvanced.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgAdvanced.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgAdvanced dialog

IMPLEMENT_DYNAMIC(CPPgAdvanced, CPropertyPage)
CPPgAdvanced::CPPgAdvanced()
	: CPropertyPage(CPPgAdvanced::IDD)
{
}

CPPgAdvanced::~CPPgAdvanced()
{
}

void CPPgAdvanced::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgAdvanced, CPropertyPage)
	ON_EN_CHANGE(IDC_BANTIMES, OnSettingsChange)
	ON_EN_CHANGE(IDC_MINREQUESTTIME, OnSettingsChange)
	ON_EN_CHANGE(IDC_BANTIMEINMINS, OnSettingsChange)
	ON_BN_CLICKED(IDC_BANMESSAGE, OnSettingsChange)
	ON_BN_CLICKED(IDC_COMENABLED, OnBnClickedComEnabled)
	ON_EN_CHANGE(IDC_COMSTRING, OnSettingsChange)
	ON_BN_CLICKED(IDC_NOBANENABLED, OnSettingsChange)
	ON_EN_CHANGE(IDC_RESTORE_SOURCES_TIME, OnSettingsChange)
	ON_EN_CHANGE(IDC_LOAD_QUANTITIES, OnSettingsChange)
	ON_EN_CHANGE(IDC_OUTDATED, OnSettingsChange)
	ON_BN_CLICKED(IDC_SLSENABLED, OnBnClickedSLSEnabled)
	ON_BN_CLICKED(IDC_MLDONKEY_CM, OnSettingsChange)
END_MESSAGE_MAP()

BOOL CPPgAdvanced::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgAdvanced::LoadSettings(void)
{
	char buffer[200];
	sprintf(buffer,"%d", app_prefs->BadClientMinRequestNum());
	GetDlgItem(IDC_BANTIMES)->SetWindowText(buffer);
	sprintf(buffer,"%d", app_prefs->BadClientBanTime()/60000);
	GetDlgItem(IDC_BANTIMEINMINS)->SetWindowText(buffer);

	CastSecondsToHM(app_prefs->BadClientMinRequestTime()/1000,buffer,5);		//Cax2 terminate the string after 10th of seconds...
	GetDlgItem(IDC_MINREQUESTTIME)->SetWindowText(buffer);

	if (app_prefs->IsBanMessageEnabled()) 
		CheckDlgButton(IDC_BANMESSAGE,1);
	else
		CheckDlgButton(IDC_BANMESSAGE,0);

	// DonGato (Community Sharing)
	GetDlgItem(IDC_COMSTRING)->SetWindowText(app_prefs->CommunityString());
	if(app_prefs->CommunityEnabled())
		CheckDlgButton(IDC_COMENABLED,1);
	else
		CheckDlgButton(IDC_COMENABLED,0);
	if(app_prefs->CommunityNoBanEnabled())
		CheckDlgButton(IDC_NOBANENABLED,1);
	else
		CheckDlgButton(IDC_NOBANENABLED,0);
	OnBnClickedComEnabled();

	// reCDVst (Load/Save Sources Settings)
	sprintf(buffer,"%d", app_prefs->RestoreSourcesTime()/60000);
	GetDlgItem(IDC_RESTORE_SOURCES_TIME)->SetWindowText(buffer);
	sprintf(buffer,"%d", app_prefs->LoadQuantities());
	GetDlgItem(IDC_LOAD_QUANTITIES)->SetWindowText(buffer);
	sprintf(buffer,"%d", app_prefs->WhenSourcesOutdated());
	GetDlgItem(IDC_OUTDATED)->SetWindowText(buffer);
	if(app_prefs->SLSEnable())
		CheckDlgButton(IDC_SLSENABLED,1);
	else
		CheckDlgButton(IDC_SLSENABLED,0);
	OnBnClickedSLSEnabled();

	if(app_prefs->GetMlDonkeyCM())
		CheckDlgButton(IDC_MLDONKEY_CM,1);
	else
		CheckDlgButton(IDC_MLDONKEY_CM,0);

	SetModified(FALSE);
}

BOOL CPPgAdvanced::OnApply()
{	
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		char buffer[200];
		int iTmp;

		GetDlgItem(IDC_BANTIMES)->GetWindowText(buffer,3);
		app_prefs->SetBadClientMinRequestNum(atoi(buffer));
		if(app_prefs->BadClientMinRequestNum() < 3)
			app_prefs->SetBadClientMinRequestNum(3);
		if(app_prefs->BadClientMinRequestNum() >10)
			app_prefs->SetBadClientMinRequestNum(10);

		sprintf(buffer, "%d",app_prefs->BadClientMinRequestNum());
		GetDlgItem(IDC_BANTIMES)->SetWindowText(buffer);

		GetDlgItem(IDC_BANTIMEINMINS)->GetWindowText(buffer,6);
		app_prefs->SetBadClientBanTime(atoi(buffer)*60000);
		if(app_prefs->BadClientBanTime() > 18000000)
			app_prefs->SetBadClientBanTime(18000000);
		if(app_prefs->BadClientBanTime() < 1800000)
			app_prefs->SetBadClientBanTime(1800000);

		sprintf(buffer, "%d",app_prefs->BadClientBanTime()/60000);
		GetDlgItem(IDC_BANTIMEINMINS)->SetWindowText(buffer);

		app_prefs->SetBanMessageEnabled(IsDlgButtonChecked(IDC_BANMESSAGE));

		GetDlgItem(IDC_MINREQUESTTIME)->GetWindowText(buffer,6);
		CString strBuffer;
		strBuffer=buffer;
		strBuffer.Replace(":",".");
		iTmp=(atof(strBuffer)-(float)atoi(strBuffer))*100.0f+0.5;
		if (iTmp>59) iTmp=59;
		app_prefs->SetBadClientMinRequestTime(atoi(strBuffer)*60000 +iTmp *1000);
		if(app_prefs->BadClientMinRequestTime() > 590000)
			app_prefs->SetBadClientMinRequestTime(590000);
		if(app_prefs->BadClientMinRequestTime() < 120000)
			app_prefs->SetBadClientMinRequestTime(120000);		
		CastSecondsToHM(app_prefs->BadClientMinRequestTime()/1000,buffer,5);		//Cax2 terminate the string after the seconds...
		GetDlgItem(IDC_MINREQUESTTIME)->SetWindowText(buffer);

		// DonGato (Community Sharing)
		GetDlgItem(IDC_COMSTRING)->GetWindowText(buffer,100);
		app_prefs->SetCommunityString(buffer);
		//strcpy(app_prefs->prefs->CommunityString,buffer);
		app_prefs->SetCommunityEnabled((int8)IsDlgButtonChecked(IDC_COMENABLED));
		app_prefs->SetCommunityNoBanEnabled((int8)IsDlgButtonChecked(IDC_NOBANENABLED));
	
		// reCDVst-DonGato (Load/Save Sources Settings)
		GetDlgItem(IDC_RESTORE_SOURCES_TIME)->GetWindowText(buffer,8);
		app_prefs->SetRestoreSourcesTime(atoi(buffer)*60000);
		if(app_prefs->RestoreSourcesTime() < 3600000){
			app_prefs->SetRestoreSourcesTime( 3600000);
			sprintf(buffer, "%d",app_prefs->RestoreSourcesTime()/60000);
			GetDlgItem(IDC_RESTORE_SOURCES_TIME)->SetWindowText(buffer);
		}
		GetDlgItem(IDC_LOAD_QUANTITIES)->GetWindowText(buffer,8);
		app_prefs->SetLoadQuantities(atoi(buffer));
		if(app_prefs->LoadQuantities() > 100){
			app_prefs->SetLoadQuantities(100);
			sprintf(buffer, "%d",app_prefs->LoadQuantities());
			GetDlgItem(IDC_LOAD_QUANTITIES)->SetWindowText(buffer);
		}
		GetDlgItem(IDC_OUTDATED)->GetWindowText(buffer,3);
		app_prefs->SetWhenSourcesOutdated(atoi(buffer));
		if(app_prefs->WhenSourcesOutdated() > 10){
			app_prefs->SetWhenSourcesOutdated(10);
			sprintf(buffer, "%d",app_prefs->WhenSourcesOutdated());
			GetDlgItem(IDC_OUTDATED)->SetWindowText(buffer);
		}
		app_prefs->SetSLSEnable((int8)IsDlgButtonChecked(IDC_SLSENABLED));

		app_prefs->SetMlDonkeyCM((int8)IsDlgButtonChecked(IDC_MLDONKEY_CM));

		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgAdvanced::Localize(void)
{
	if(m_hWnd){
		SetWindowText(GetResString(IDS_PW_ADVANCED));
		GetDlgItem(IDC_BAN)->SetWindowText(GetResString(IDS_BAN));
		GetDlgItem(IDC_CLIENTREQUESTLBL)->SetWindowText(GetResString(IDS_CLIENTREQUESTLBL));
		GetDlgItem(IDC_BANFORLABEL)->SetWindowText(GetResString(IDS_BANFORLABEL));
		GetDlgItem(IDC_TIMESINLBL)->SetWindowText(GetResString(IDS_TIMESINLBL));
		GetDlgItem(IDC_MINUTES_BAN1)->SetWindowText(GetResString(IDS_MINS));
		GetDlgItem(IDC_MINUTES_BAN2)->SetWindowText(GetResString(IDS_MINS));
		GetDlgItem(IDC_COM)->SetWindowText(GetResString(IDS_COM));
		GetDlgItem(IDC_COMENABLED)->SetWindowText(GetResString(IDS_ENABLED));
		GetDlgItem(IDC_NOBANENABLED)->SetWindowText(GetResString(IDS_NOBANENABLED));
		GetDlgItem(IDC_BANMESSAGE)->SetWindowText(GetResString(IDS_BANMESSAGE));
		GetDlgItem(IDC_SAVELOADSOURCESGROUPBOX)->SetWindowText(GetResString(IDS_SAVELOADSOURCESGROUPBOX));
		GetDlgItem(IDC_SLS_LOAD_QUANTITY)->SetWindowText(GetResString(IDS_SLS_LOAD_QUANTITY));
		GetDlgItem(IDC_SLS_LOAD_EVERY)->SetWindowText(GetResString(IDS_SLS_LOAD_EVERY));
		GetDlgItem(IDC_SLS_OUTDATED)->SetWindowText(GetResString(IDS_SLS_OUTDATED));
		GetDlgItem(IDC_SLS_MINS)->SetWindowText(GetResString(IDS_MINS));
		GetDlgItem(IDC_SLS_SOURCES)->SetWindowText(GetResString(IDS_SOURCES_PF_FILES));
		GetDlgItem(IDC_SLS_DAYS)->SetWindowText(GetResString(IDS_DAYS));
		GetDlgItem(IDC_SLSENABLED)->SetWindowText(GetResString(IDS_ENABLED));
		GetDlgItem(IDC_MLDONKEY_CM)->SetWindowText(GetResString(IDS_MLDONKEY_CM));
	}
}

void CPPgAdvanced::OnBnClickedComEnabled()
{
	GetDlgItem(IDC_COMSTRING)->EnableWindow(IsDlgButtonChecked(IDC_COMENABLED));
	GetDlgItem(IDC_NOBANENABLED)->EnableWindow(IsDlgButtonChecked(IDC_COMENABLED));

	SetModified();
}

void CPPgAdvanced::OnBnClickedSLSEnabled()
{
	GetDlgItem(IDC_RESTORE_SOURCES_TIME)->EnableWindow(IsDlgButtonChecked(IDC_SLSENABLED));	
	GetDlgItem(IDC_LOAD_QUANTITIES)->EnableWindow(IsDlgButtonChecked(IDC_SLSENABLED));	
	GetDlgItem(IDC_OUTDATED)->EnableWindow(IsDlgButtonChecked(IDC_SLSENABLED));	

	SetModified();
}
