//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// ServerWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ServerWnd.h"
#include "HttpDownloadDlg.h"
#include "NewServerDlg.h"
#include "UpdateServerMetDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CServerWnd dialog

IMPLEMENT_DYNAMIC(CServerWnd, CDialog)
CServerWnd::CServerWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CServerWnd::IDD, pParent) 
{
	m_dlgNewServer.SetParent(this);
	m_dlgUpdateServerMet.SetParent(this);
}

CServerWnd::~CServerWnd()
{	
}

BOOL CServerWnd::OnInitDialog()
{
	CResizableDialog::OnInitDialog();
		
	serverlistctrl.Init(theApp.serverlist);
	
///////////////////////////////////////////////////
	CImageList imagelist;
	imagelist.Create(16,16,ILC_COLOR32,0,10);
	imagelist.SetBkColor(RGB(255,0,255));
	imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_LOG),16,16));
	imagelist.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SERVERINFO),16,16));
	LoadImgLstIcon(NULL,0,0); // Delete temp-icon
	CImageList ImageList;
	CBitmap Bitmap, *pOldBitmap;
	CDC *pCtrlDC = GetDC(), TempDC;
	TempDC.CreateCompatibleDC(pCtrlDC);
	Bitmap.CreateCompatibleBitmap(pCtrlDC, 16 * 2, 16);
	pOldBitmap = TempDC.SelectObject(&Bitmap);
	imagelist.Draw(&TempDC, 0, CPoint( 0,0), ILD_NORMAL);
	imagelist.Draw(&TempDC, 1, CPoint(16,0), ILD_NORMAL);
	TempDC.SelectObject(pOldBitmap);
	ImageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 10);
	ImageList.Add(&Bitmap, RGB(255,0,255));
	m_ctrlBoxSwitcher.SetImageList(&ImageList);
	ImageList.Detach();
	// FoRcHa
	//Bitmap.Detach();
	Bitmap.DeleteObject();
	ReleaseDC(pCtrlDC);
///////////////////////////////////////////////////////

	m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 0, GetResString(IDS_SV_LOG), 0,0,0,0);
	m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 1, GetResString(IDS_SV_SERVERINFO), 1,0,0,0);

	CRect rBox;
	logbox.GetWindowRect(&rBox);
	ScreenToClient(rBox);
	debugbox.GetWindowRect(&rBox);
	ScreenToClient(rBox);
	servermsgbox.CreateEx(WS_EX_STATICEDGE, NULL, "MsgWnd", WS_CHILD | WS_HSCROLL | WS_VSCROLL | HTC_WORDWRAP 
						| HTC_AUTO_SCROLL_BARS | HTC_UNDERLINE_HOVER, rBox, this, rand());
	InitFont();	
	((CStatic*)GetDlgItem(IDC_SERVLST_ICO))->SetIcon((HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_SERVERLIST), IMAGE_ICON, 16, 16, 0));
	servermsgbox.AppendText(CString(CString("eMule Plus V")+CString(CURRENT_VERSION_LONG)+CString("  http://emuleplus.sf.net\n")));
	servermsgbox.AppendText(GetResString(IDS_EMULEW)+CString(" "),false);
	CString strLink;
	// Plus has his own version check now
	strLink.Format("http://emuleplus.sourceforge.net/version_check.php?version=%i&language=%i",CURRENT_PLUS_VERSION,theApp.glob_prefs->GetLanguageID());
	servermsgbox.AppendHyperLink(GetResString(IDS_EMULEW3)+CString(" "),0,strLink,0,false);
	servermsgbox.AppendText(GetResString(IDS_EMULEW2),false);
	// End version check
	servermsgbox.AppendText(CString("\n\n"));
	
	m_ctrlNewServerBtn.SetThemeHelper(&theApp.emuledlg->m_ThemeHelper);
	m_ctrlNewServerBtn.SetIcon(IDI_NEWSERVER);
	m_ctrlNewServerBtn.SetButtonStyle(0,TBBS_AUTOSIZE); // DonGato
	m_ctrlUpdateServerMetBtn.SetThemeHelper(&theApp.emuledlg->m_ThemeHelper);
	m_ctrlUpdateServerMetBtn.SetIcon(IDI_UPDATESERVERS);
	m_ctrlUpdateServerMetBtn.SetButtonStyle(0,TBBS_AUTOSIZE); // DonGato
	m_ctrlResetLogBtn.SetThemeHelper(&theApp.emuledlg->m_ThemeHelper);
	m_ctrlResetLogBtn.SetIcon(IDI_RESETLOG);
	m_ctrlResetLogBtn.SetButtonStyle(0,TBBS_AUTOSIZE); // DonGato

	AddAnchor(IDC_SERVLST_ICO, TOP_LEFT);
	AddAnchor(IDC_SERVLIST_TEXT, TOP_LEFT);
	AddAnchor(IDC_SERVLIST, TOP_LEFT, MIDDLE_RIGHT);
	AddAnchor(IDC_TAB1, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(servermsgbox, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(logbox, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(debugbox, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_NEWSERVER, TOP_RIGHT);
	AddAnchor(IDC_UPDATESERVERMET, TOP_RIGHT);
	AddAnchor(IDC_LOGRESET, MIDDLE_RIGHT);
	debug = false;
	ToggleDebugWindow();
	Localize();

	return true;
}
void CServerWnd::InitFont()
{
	logbox.SetFont(&theApp.emuledlg->m_DefaultFont); // DonGato
	debugbox.SetFont(&theApp.emuledlg->m_DefaultFont); // DonGato
	servermsgbox.SetFont(&theApp.emuledlg->m_DefaultFont);
}

void CServerWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SERVLIST, serverlistctrl);
	DDX_Control(pDX, IDC_LOGBOX, logbox);
	DDX_Control(pDX, IDC_DEBUG_LOG, debugbox);
	DDX_Control(pDX, IDC_NEWSERVER, m_ctrlNewServerBtn);
	DDX_Control(pDX, IDC_UPDATESERVERMET, m_ctrlUpdateServerMetBtn);
	DDX_Control(pDX, IDC_TAB1, m_ctrlBoxSwitcher);
	DDX_Control(pDX, IDC_LOGRESET, m_ctrlResetLogBtn);
}

void CServerWnd::Localize() 
{
	if(m_hWnd)
	{		
		serverlistctrl.Localize();

		char buffer[256];
		TCITEM ti;
		ti.mask = TCIF_TEXT;
		ti.pszText = buffer;
		ti.cchTextMax = sizeof(buffer);
        
		m_ctrlBoxSwitcher.GetItem(0, &ti);
		sprintf(buffer, "%s", GetResString(IDS_SV_LOG));
		m_ctrlBoxSwitcher.SetItem(0, &ti);
		m_ctrlBoxSwitcher.GetItem(1, &ti);
		sprintf(buffer, "%s", GetResString(IDS_SV_SERVERINFO));
		m_ctrlBoxSwitcher.SetItem(1, &ti);
		if (theApp.glob_prefs->GetVerbose() && debug == true)
		{
		m_ctrlBoxSwitcher.GetItem(2, &ti);
		sprintf(buffer, "%s", GetResString(IDS_SV_DEBUGLOG));
		m_ctrlBoxSwitcher.SetItem(2, &ti);
		theApp.emuledlg->AddDebugLogLine(false,"Debug log is active");
		}
		m_ctrlBoxSwitcher.Invalidate();
		logbox.Invalidate();
		debugbox.Invalidate();
		servermsgbox.Invalidate();
		m_ctrlBoxSwitcher.SetWindowPos(&CWnd::wndBottom,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE); // DonGato

		GetDlgItem(IDC_SERVLIST_TEXT)->SetWindowText(GetResString(IDS_SV_SERVERLIST));
		
		m_ctrlNewServerBtn.SetWindowText(GetResString(IDS_SV_NEWSERVER));
		m_ctrlUpdateServerMetBtn.SetWindowText(GetResString(IDS_SV_MET));
		m_ctrlResetLogBtn.SetWindowText(GetResString(IDS_PW_RESET));
	}
}

BEGIN_MESSAGE_MAP(CServerWnd, CResizableDialog)
	ON_BN_CLICKED(IDC_LOGRESET, OnBnClickedResetLog)
	ON_BN_CLICKED(IDC_UPDATESERVERMET, OnBnClickedUpdateservermet)
	ON_BN_CLICKED(IDC_NEWSERVER, OnBnClickedNewserver)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
END_MESSAGE_MAP()


// CServerWnd message handlers
void CServerWnd::OnBnClickedResetLog() 
{	
	switch(m_ctrlBoxSwitcher.GetCurSel())	// clear the visible textbox [FoRcHa]
	{
		case 0:
			theApp.emuledlg->ResetLog();
			break;
		case 1:
			servermsgbox.SetWindowText( "" );
			break;
		case 2:
			theApp.emuledlg->ResetDebugLog();
			break;
		default:
			break;
	}
}

void CServerWnd::OnBnClickedNewserver()
{
	CRect rBtn;
	GetDlgItem(IDC_NEWSERVER)->GetWindowRect(&rBtn);
	m_dlgNewServer.SetInitialPos(CPoint(rBtn.right,rBtn.bottom), 1);
	m_dlgNewServer.DoModal();
}

void CServerWnd::OnBnClickedUpdateservermet()
{
	CRect rBtn;
	GetDlgItem(IDC_UPDATESERVERMET)->GetWindowRect(&rBtn);
	m_dlgUpdateServerMet.SetInitialPos(CPoint(rBtn.right,rBtn.bottom), 1);
	m_dlgUpdateServerMet.DoModal();
}

void CServerWnd::AddServer(CString serveraddr, CString portstr, CString servername)
{	
	if(!serveraddr.GetLength())
	{
		theApp.emuledlg->AddLogLine(true, GetResString(IDS_SRV_ADDR));
		return;
	}

	if(!portstr.GetLength())
	{
		theApp.emuledlg->AddLogLine(true, GetResString(IDS_SRV_PORT));
		return;
	}

	CServer* toadd = new CServer(atoi(portstr),serveraddr.GetBuffer());

	// Barry - Default all manually added servers to high priority
	if( theApp.glob_prefs->GetManualHighPrio() )
		toadd->SetPreference(PR_HIGH);

	if(servername.GetLength())
		toadd->SetListName(servername.GetBuffer());
	else
		toadd->SetListName(serveraddr.GetBuffer());
	
	if (!serverlistctrl.AddServer(toadd,true))
	{
		CServer* update = theApp.serverlist->GetServerByAddress(toadd->GetAddress(), toadd->GetPort());
		if(update)
		{
			update->SetListName(toadd->GetListName());
			serverlistctrl.RefreshServer(update);
		}
		delete toadd;
		theApp.emuledlg->AddLogLine(true, GetResString(IDS_SRV_NOTADDED) );
	} 
	else 
		theApp.emuledlg->AddLogLine(true,GetResString(IDS_SERVERADDED)+CString(toadd->GetListName()));
	
	theApp.serverlist->SaveServermetToFile();
}

void CServerWnd::UpdateServerMetFromURL(CString strURL)
{
	if(strURL == "")
	{
		theApp.serverlist->AutoUpdate(); 
		
		// Load Metfile
		CString strPath = theApp.glob_prefs->GetAppDir() + CString("server.met");
		theApp.serverlist->AddServermetToList(strPath, true);	// this merges servers
	
		// insert static servers from textfile
		strPath = theApp.glob_prefs->GetAppDir() + CString("staticservers.dat");
		theApp.serverlist->AddServersFromTextFile(strPath);
	}
	else
	{
		if (strURL != "" && strURL.Find("://") == -1)	// not a valid URL
			{
				theApp.emuledlg->AddLogLine(true, GetResString(IDS_INVALIDURL));
				return;
			}
		CString strTempFilename;
		strTempFilename.Format("%stemp-%d-server.met", theApp.glob_prefs->GetAppDir(), ::GetTickCount());
	
		CHttpDownloadDlg dlgDownload;
		dlgDownload.m_sURLToDownload = strURL;
		dlgDownload.m_sFileToDownloadInto = strTempFilename;
		if(dlgDownload.DoModal() != IDOK)
		{
			theApp.emuledlg->AddLogLine(true, GetResString(IDS_ERR_FAILEDDOWNLOADMET), strURL);
			return;
		}
	
	//	serverlistctrl.Hide();		
		serverlistctrl.SetRedraw(false);	// FoRcHa
		serverlistctrl.AddServermetToList(strTempFilename);
	//	serverlistctrl.Visable();
		serverlistctrl.SetRedraw(true);
		remove(strTempFilename);
		theApp.serverlist->SaveServermetToFile();
	}
}

void CServerWnd::OnStnClickedServinfIco()
{
	// TODO: Add your control notification handler code here
}

void CServerWnd::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	switch(m_ctrlBoxSwitcher.GetCurSel())
	{
		case 0:
			debugbox.ShowWindow(SW_HIDE);
			servermsgbox.ShowWindow(SW_HIDE);
			logbox.ShowWindow(SW_SHOW);
			break;
		case 1:
			debugbox.ShowWindow(SW_HIDE);
			servermsgbox.ShowWindow(SW_SHOW);
			logbox.ShowWindow(SW_HIDE);
			break;
		case 2:
			debugbox.ShowWindow(SW_SHOW);
			servermsgbox.ShowWindow(SW_HIDE);
			logbox.ShowWindow(SW_HIDE);
			break;
		default:
			break;
	}

	*pResult = 0;
}

//used now!
void CServerWnd::ToggleDebugWindow(){
	//theApp.emuledlg->AddLogLine(true," get verbose = %i  :: debug = %i",theApp.glob_prefs->GetVerbose() , debug == false);
	int cur_sel = m_ctrlBoxSwitcher.GetCurSel();
	if( theApp.glob_prefs->GetVerbose() && debug == false ){
		//theApp.emuledlg->AddLogLine(true,"should switch");
		m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 2, GetResString(IDS_SV_DEBUGLOG), 0,0,0,0);
		debug = true;
	}
	else if( !theApp.glob_prefs->GetVerbose() && debug == true ) {
		if( cur_sel == 2 ){
			m_ctrlBoxSwitcher.SetCurSel(0);		//log box
			m_ctrlBoxSwitcher.SetFocus();
		}
		debugbox.ShowWindow(SW_HIDE);
		servermsgbox.ShowWindow(SW_HIDE);
		logbox.ShowWindow(SW_SHOW);
		m_ctrlBoxSwitcher.DeleteItem(2);
		debug = false;
	}
}

void CServerWnd::OnCancel()
{
	//CResizableDialog::OnCancel();	// pressing ESC when the focus is on the logbox									// would hide the server-wnd [FoRcHa]
}
